/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */

 //The URLS that they want to link to
var urls = [];
//The names of the sites they want to link to
var names = [];
//The name of the site they want to remove
var siteToRemove;

/**
 * Opens the form to add a website
 */
window.onload = function () {
    update();
    urls = JSON.parse(localStorage.getItem("urls"));
    names = JSON.parse(localStorage.getItem("names"));
};

/**
 * Opens the form to add a website
 */
function openForm() {
    document.getElementById("myForm").style.display = "block";
}

/**
 * Changes the images to show the images for deleting a link
 */
function showRemoveButtons() {
    document.getElementById("remove-button").style.display = "none";
    document.getElementById("cancel-remove-button").style.display = "block";
    var x = document.getElementsByClassName("favicon");
    var i;
    //Goes through all the favicons to the websites and changes the
    //dispaly to none.
    for (i = 0; i < x.length; i++) {
        x[i].style.display = "none";
    }
    var y = document.getElementsByClassName("delete");
    var j;
    //Goes through all the images to be show when they want to delete a link
    //and changes dispaly to inline-block.
    for (j = 0; j < y.length; j++) {
        y[j].style.display = "inline-block";
    }
}

/**
 * Cancels the remove a link function and changes back the images
 */
function cancelRemove() {
    document.getElementById("cancel-remove-button").style.display = "block";
    var y = document.getElementsByTagName("IMG");
    var i;
    for (i = 0; i < y.length; i++) {
        y[i].style.textAlign = "center";
        y[i].style.display = "";
    }
    document.getElementById("cancel-remove-button").style.display = "none";
    document.getElementById("remove-button").style.display = "block";

}

/**
 * Closes the form to add a link to a website
 */
function closeForm() {
    document.getElementById("myForm").style.display = "none";
}

/**
 * Function for adding a link to a website and stores it in LocalStorage
 */
function add() {
    if (document.getElementById("url").value) {
        var url = document.getElementById("url").value.toString();
        urls.push("" + url);
        var name = document.getElementById("sitename").value.toString();
        localStorage.setItem("urls", JSON.stringify(urls));

        if (name) {
            var res = name;
            names.push("" + res);
        } else {
            var res = url.replace("http://", "").replace("https://", "").replace("www.", "")
                    .replace(".no", "").replace(".com", "").replace(".org", "")
                    .replace(".net", "");
            names.push("" + res);
        }
        var urlinput = document.getElementById("url");
        var nameinput = document.getElementById("sitename");
        localStorage.setItem("names", JSON.stringify(names));
        createLink(url, res);
        urlinput.value = "";
        nameinput.value = "";
        closeForm();
        console.log(localStorage.getItem("urls"));
    }
}

/**
 * Updates the website to show all the links stored in localStorage
 */
function update() {
    urls1 = JSON.parse(localStorage.getItem("urls"));
    names1 = JSON.parse(localStorage.getItem("names"));
    for (i = 0; i < urls1.length; i++) {

        url = urls1[i];
        name = names1[i];
        createLink(url, name);
    }
}

/**
 * Creates a li tag with a hyperlink to the website they want to show
 * @param {type} url ,the url to the site they want to add
 * @param {type} name ,the name of the site.
 */
function createLink(url, name) {
    var node = document.createElement("li");
    node.setAttribute("onclick", "getSiteName(this)");

    var aNode = document.createElement("a");
    if (!url.indexOf("http")) {
        aNode.href = url;
    } else {
        aNode.href = "http://" + url;
    }

    var imgNode = document.createElement("img");
    imgNode.src = "http://www.google.com/s2/favicons?domain=" + url;
    imgNode.className = "favicon";
    imgNode.setAttribute("alt","Logoen til " + name);
    aNode.appendChild(imgNode);


    var pNode = document.createElement("p");
    var brNode = document.createElement("br");
    pNode.appendChild(brNode);


    var textnode = document.createTextNode(name);
    pNode.appendChild(textnode);
    aNode.appendChild(pNode);

    var imgNode2 = document.createElement("img");
    imgNode2.src = "delete.png";
    imgNode2.className = "delete";
    imgNode2.setAttribute("onclick", "myFunction()");

    node.appendChild(aNode);
    node.appendChild(imgNode2);

    document.getElementById("liste").appendChild(node);
}

/**
 * Gets the name of the site the clicked on that they want to remove
 * @param {type} link ,the link they clicked
 */
function getSiteName(link){
    var TextInside = link.getElementsByTagName('p')[0].innerHTML.toString().trim();
    var siteName = TextInside.replace("<br>","");
    console.log(siteName);

    siteToRemove = siteName;
}

/**
 * Sets a timeout for the remove function so it can get the name
 * before it removes it
 */
function myFunction() {
  myVar = setTimeout(remove, 20);
}

/**
 * Function for removing a link from the site and delets it from localStorage
 */
function remove() {
    var siteName = siteToRemove;
    console.log("sitename: " + siteName);

    for (var i = 0; i < names.length; i++) {
        if (names[i] === siteName) {
            urls.splice(i, 1);
            names.splice(i, 1);
        }

    }
    localStorage.setItem("urls", JSON.stringify(urls));
    localStorage.setItem("names", JSON.stringify(names));
    document.location.reload();
}
