var BUTTON_BACK = 2;
var BUTTON_FORWARD = 1;
var BUTTON_STOP = 3;
var BUTTON_RELOAD = 4;
var BUTTON_HOME = 5;
var BUTTON_SEARCH = 6;
var BUTTON_FAVORITES = 13;
var BUTTON_WEBCAM = 10;
var BUTTON_PROGRAMS = 9;
var BUTTON_MAIL = 8;
var BUTTON_PRINT = 7;
var BUTTON_LOGOUT = 11;

var Desktop = null;

var origStartpage = "";

var IconWidth = 32;

var IconTextColor = "#000000";
var IconTextOverColor = "#FFFFFF";
var IconTextOverBG = "#316AC5";

var FontSize = "8pt";
var FontFamily = "Tahoma";

var DesktopBGColor = "";//"#FFFFFF";

var CellWidth = 90;
var OneClickIcons = false;
var DropShadowIcons = false;

var ShowPrograms = false;
var ShowMail = false;
var ShowMMail = false;
var MoveIcons = true;
var ShowWBrowser = true;


var ShowShutdown = false;

var CopyrightInfo = "SiteKiosk - Public Access Terminal Software";

function getValues()
{
	if (Configs.getConfigValue("newwindow-startpage", true).length > 0)
		origStartpage = Configs.getConfigValue("newwindow-startpage", true).replace("$(SiteKioskPath)\\", SiteKiosk.SiteKioskDirectory);
	
	if (Configs.getConfigValue("IconWidth").length > 0)
		IconWidth = Configs.getConfigValue("IconWidth");
	
	if (Configs.getConfigValue("MoveIcons").length > 0)
		MoveIcons = Configs.getConfigValue("MoveIcons").toLowerCase()!=="false";

	if (Configs.getConfigValue("TextColor").length > 0)
		IconTextColor = Configs.getConfigValue("TextColor");

	if (Configs.getConfigValue("TextOverColor").length > 0)
		IconTextOverColor = Configs.getConfigValue("TextOverColor");

	if (Configs.getConfigValue("TextOverBGColor").length > 0)
		IconTextOverBG = Configs.getConfigValue("TextOverBGColor");

	if (Configs.getConfigValue("OCI").length > 0)
		OneClickIcons = Configs.getConfigValue("OCI").toLowerCase()!=="false";

	if (Configs.getConfigValue("DropShadow").length > 0)
		DropShadowIcons = Configs.getConfigValue("DropShadow").toLowerCase()!=="false";

	if (Configs.getConfigValue("ShowWBrowser").length > 0)
		ShowWBrowser = Configs.getConfigValue("ShowWBrowser").toLowerCase()!== "false";
	
	if (Configs.getConfigValue("FontFamily").length > 0)
		FontFamily = Configs.getConfigValue("FontFamily");

	if (Configs.getConfigValue("FontSize").length > 0)
		FontSize = Configs.getConfigValue("FontSize");

	if (Configs.getConfigValue("DesktopBG").length > 0)
	{
		desktopBG = Configs.getConfigValue("DesktopBG");
		if (desktopBG.indexOf("color") != -1)
			DesktopBGColor = desktopBG.replace(/color/, "");
		else
			DesktopBGColor = desktopBG;
	}
	
	if (Configs.getConfigValue("DesktopCopyright").length > 0)
		CopyrightInfo = Configs.getConfigValue("DesktopCopyright");

	if (Configs.getConfigValue("ShowShutdown").length > 0)
		ShowShutdown = Configs.getConfigValue("ShowShutdown").toLowerCase() !== "false";

	try {
		ShowPrograms = SiteKiosk.Config.XMLDocument.selectSingleNode("//sitekiosk-configuration/programs").getAttribute("enabled") !== "false";
		ShowMail = SiteKiosk.Config.XMLDocument.selectSingleNode("//sitekiosk-configuration/email/action").text !== "0";
		ShowMMail = SiteKiosk.Config.XMLDocument.selectSingleNode("//sitekiosk-configuration/plugin[@name=\"SiteCam\"]").getAttribute("enabled") !== "false";
	} catch (ex) { }
}

function Initialize()
{
	document.body.scroll = "no";
	
	InitConfig();
	DesktopBGColor = SiteKiosk.SiteKioskDirectory+"SystemSecurity\\wallpaper.jpg";
	getValues();
	Desktop = new _Desktop(divDesktop, CopyrightInfo, DesktopBGColor, CellWidth, OneClickIcons, DropShadowIcons, FontSize, FontFamily, IconTextColor, IconTextOverColor, IconTextOverBG);
	CreateIcons();
}

function doNotification(i)
{
	var dispText = SiteKiosk.ExternalApps(i).Path;
	SiteKiosk.Logfile.Notification("Application '" + dispText + "' was started!");
}

function StartProg(number)
{
	try
	{
		if (!SiteKiosk.Plugins("SiteCash").PayApplications || SiteKiosk.Plugins("SiteCash").Enabled && SiteKiosk.Plugins("SiteCash").AccessStatus || SiteKiosk.Plugins("SiteCash").Enabled && SiteKiosk.Plugins("SiteCash").CreditStatus || !SiteKiosk.Plugins("SiteCash").Enabled)
		{
			SiteKiosk.ExternalApps(number).Run(true);
			doNotification(number);
			gbStartProgs = true;
		}
		else
		{
			SiteKiosk.Plugins("SiteCash").ShowPaymentInfoDialog(0, "", false);
		}
	}
	catch(e)
	{
		SiteKiosk.ExternalApps(number).Run(true);
		doNotification(number);
		gbStartProgs = true;
	}
}

var SkinStringTable = null;

function CreateIcons()
{
	SkinStringTable = SiteKiosk.WindowList.MainWindow.SiteKioskWindow.StringTable;
	
	if (ShowShutdown)
	{
		shutdown =  new _Icon(SiteKiosk.SiteKioskDirectory + "skins\\public\\Startpages\\Desktop\\Img\\shutdown.ico", "shutdownwin", SkinStringTable.LoadString(6012), "SiteKiosk.ShutdownWindows();", IconWidth);
		shutdown.PlaceIcon(shutdown.GetRastaX(5), shutdown.GetRastaY(Desktop.Icons.length*Desktop.cellSize-10), divDesktop);
	}

	if (ShowWBrowser)
	{
		SiteKiosk.Logfile.Notification("222222222222: " + ShowWBrowser);
		work =  new _Icon(SiteKiosk.SiteKioskDirectory + "skins\\public\\Startpages\\Desktop\\Img\\sitekiosk.ico", "mycomputer", SkinStringTable.LoadString(500), "window.open(origStartpage);", IconWidth);
		work.PlaceIcon(work.GetRastaX(5), work.GetRastaY(5), divDesktop);
	}
	
	var MMailX;
	
	if (ShowMail)
	{
		email = new _Icon(SiteKiosk.SiteKioskDirectory + "skins\\public\\Startpages\\Desktop\\Img\\mail.ico", "mail", SkinStringTable.LoadString(8), "window.open(\""+SiteKiosk.URLs.Email+"\");", IconWidth);
		
		if(ShowWBrowser)
		{
			email.PlaceIcon(email.GetRastaX(Desktop.cellSize), email.GetRastaY(5), divDesktop);
			MMailX = email.GetRastaX(Desktop.cellSize*2);
		}
		else
		{
			email.PlaceIcon(email.GetRastaX(5), email.GetRastaY(5), divDesktop);
			MMailX = email.GetRastaX(Desktop.cellSize);
		}
	}
	if (ShowMMail)
	{
		mmemail = new _Icon(SiteKiosk.SiteKioskDirectory + "skins\\public\\Startpages\\Desktop\\Img\\media_mail.ico", "mediamail", SkinStringTable.LoadString(2001), "window.open(\""+SiteKiosk.URLs.MediaMail+"\");", IconWidth);
		mmemail.PlaceIcon(MMailX || mmemail.GetRastaX(Desktop.cellSize), mmemail.GetRastaY(5), divDesktop);
	}

	if (ShowPrograms)
	{
		var y = 5;
		var rowCount = 2;
		var x = screen.width-Desktop.cellSize*rowCount;
		
		for (var n = 1; n <= SiteKiosk.ExternalApps.Count; ++n)
		{
			if (y/Desktop.cellSize >= parseInt(screen.height/Desktop.cellSize)-1)
			{
				y = 5;
				x = screen.width-Desktop.cellSize*(++rowCount);
			}
			var DispText = "";
			if (SiteKiosk.ExternalApps(n).Title == "")
				DispText = SiteKiosk.ExternalApps(n).Path;
			else
				DispText = SiteKiosk.ExternalApps(n).Title;

			prog = new _Icon(SiteKiosk.ExternalApps(n).Path, "prog"+n, DispText, "StartProg("+n+");", IconWidth);
			prog.PlaceIcon(prog.GetRastaX(x), prog.GetRastaY(y), divDesktop);//screen.width-Desktop.cellSize*2
			
			y += Desktop.cellSize;
		}
	}
}
